Package net.sf.saxon.tree.util

## Class Orphan

- java.lang.Object
- - net.sf.saxon.tree.util.Orphan

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `MutableNodeInfo`, `NodeInfo`, `Sequence`, `Location`, `org.xml.sax.Locator`

      public final class Orphan
      extends java.lang.Object
      implements MutableNodeInfo

  A node (implementing the NodeInfo interface) representing an attribute, text node, comment, processing instruction, or namespace that has no parent (and of course no children). Exceptionally it is also used (during whitespace stripping) to represent a standalone element.

  In general this class does not impose constraints defined in the data model: that is the responsibility of the client. For example, the class does not prevent you from creating a comment or text node that has a name or a non-trivial type annotation.

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Orphan​(Configuration config)` | Create an Orphan node

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addAttribute​(NodeName nameCode, SimpleType attType, java.lang.CharSequence value, int properties, boolean inheritNamespaces)` | Add an attribute to this element node.
    `void` | `addNamespace​(NamespaceBinding nscode, boolean inherit)` | Add a namespace binding (that is, a namespace node) to this element.
    `AtomicSequence` | `atomize()` | Get the typed value.
    `int` | `compareOrder​(NodeInfo other)` | Determine the relative position of this node and another node, in document order.
    `void` | `delete()` | Delete this node (that is, detach it from its parent).
    `boolean` | `effectiveBooleanValue()` | Get the effective boolean value of this sequence
    `boolean` | `equals​(NodeInfo other)` | Determine whether this is the same node as another node.
    `void` | `generateId​(FastStringBuffer buffer)` | Get a character string that uniquely identifies this node.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node
    `java.lang.String` | `getBaseURI()` | Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace undeclarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `int` | `getFingerprint()` | Get fingerprint.
    `java.lang.String` | `getLocalPart()` | Get the local part of the name of this node.
    `int` | `getNodeKind()` | Return the kind of node.
    `NodeInfo` | `getParent()` | Get the NodeInfo object representing the parent of this node
    `java.lang.String` | `getPrefix()` | Get the prefix of the name of the node.
    `java.lang.String` | `getPublicId()` | Get the Public ID of the entity containing the node.
    `NodeInfo` | `getRoot()` | Get the root node of this tree (not necessarily a document node).
    `SchemaType` | `getSchemaType()` | Get the type annotation of this node, if any.
    `java.lang.String` | `getStringValue()` | Return the string value of the node.
    `java.lang.CharSequence` | `getStringValueCS()` | Get the value of the item as a CharSequence.
    `java.lang.String` | `getSystemId()` | Get the System ID for the node.
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `java.lang.String` | `getURI()` | Get the URI part of the name of this node.
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool.
    `int` | `hashCode()` | The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `void` | `insertChildren​(NodeInfo[] source, boolean atStart, boolean inherit)` | Insert copies of a sequence of nodes as children of this node.
    `void` | `insertSiblings​(NodeInfo[] source, boolean before, boolean inherit)` | Insert copies of a sequence of nodes as siblings of this node.
    `boolean` | `isDeleted()` | Test whether this MutableNodeInfo object represents a node that has been deleted.
    `boolean` | `isDisableOutputEscaping()` | Ask whether the node has the disable-output-escaping property
    `boolean` | `isId()` | Ask whether this node has the is-id property
    `boolean` | `isIdref()` | Ask whether this node has the is-idref property
    `AxisIterator` | `iterateAxis​(int axisNumber)` | Return an iteration over the nodes reached by the given axis from this node
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iteration over the nodes reached by the given axis from this node
    `Builder` | `newBuilder()` | Get a Builder suitable for building nodes that can be attached to this document.
    `void` | `removeAttribute​(NodeInfo attribute)` | Remove an attribute from this element node
    `void` | `removeTypeAnnotation()` | Remove type information from this node (and its ancestors, recursively).
    `void` | `rename​(NodeName newNameCode, boolean inheritNamespaces)` | Rename this node.
    `void` | `replace​(NodeInfo[] replacement, boolean inherit)` | Replace this node with a given sequence of nodes
    `void` | `replaceStringValue​(java.lang.CharSequence stringValue)` | Replace the string-value of this node.
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setAttributes​(AttributeMap attributes)` | Set the attribute list for this (element) node
    `void` | `setDisableOutputEscaping​(boolean doe)` | Set the disable-output-escaping property
    `void` | `setIsId​(boolean id)` | Set the isId property
    `void` | `setIsIdref​(boolean idref)` | Set the isIdref property
    `void` | `setNodeKind​(short kind)` | Set the node kind
    `void` | `setNodeName​(NodeName nodeName)` | Set the name of the node
    `void` | `setStringValue​(java.lang.CharSequence stringValue)` | Set the string value of the node
    `void` | `setSystemId​(java.lang.String systemId)` | Set the system identifier for this Source.
    `void` | `setTypeAnnotation​(SchemaType typeAnnotation)` | Set the type annotation of the node

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, head, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.MutableNodeInfo

      `addNamespace, removeNamespace`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `attributes, children, children, copy, equals, getColumnNumber, getConfiguration, getGenre, getLineNumber, isNilled, isSameNodeInfo, isStreamed, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

- - ### Constructor Detail

    - #### Orphan

          public Orphan​(Configuration config)

      Create an Orphan node
      Parameters:
        `config` - the Saxon configuration

  - ### Method Detail

    - #### getTreeInfo

          public TreeInfo getTreeInfo()

      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Returns:
        the TreeInfo
      Since:
        9.7

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the System ID for the node. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot. The base URI is used primarily for resolving relative URIs within the content of the document. The system ID is used primarily in conjunction with a line number, for identifying the location of elements within the source XML, in particular when errors are found. For a document node, the System ID represents the value of the document-uri property as defined in the XDM data model.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known or not applicable.
      Since:
        8.4

    - #### getPublicId

          public java.lang.String getPublicId()

      Get the Public ID of the entity containing the node.
      Specified by:
        `getPublicId` in interface `Location`
      Specified by:
        `getPublicId` in interface `org.xml.sax.Locator`
      Specified by:
        `getPublicId` in interface `NodeInfo`
      Specified by:
        `getPublicId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the Public Identifier of the entity in the source document containing the node, or null if not known or not applicable
      Since:
        9.7

    - #### setSystemId

          public void setSystemId​(java.lang.String systemId)

      Set the system identifier for this Source.

      The system identifier is optional if the source does not get its data from a URL, but it may still be useful to provide one. The application can use a system identifier, for example, to resolve relative URIs and to include in error messages and warnings.

      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`
      Parameters:
        `systemId` - The system identifier as a URL string.

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue()

      Get the effective boolean value of this sequence
      Specified by:
        `effectiveBooleanValue` in interface `GroundedValue`
      Returns:
        the effective boolean value (always true for an Orphan node)

    - #### setNodeKind

          public void setNodeKind​(short kind)

      Set the node kind
      Parameters:
        `kind` - the kind of node, for example `Type.ELEMENT` or `Type.ATTRIBUTE`

    - #### setNodeName

          public void setNodeName​(NodeName nodeName)

      Set the name of the node
      Parameters:
        `nodeName` - the name of the node. May be null for unnamed nodes such as text and comment nodes

    - #### setStringValue

          public void setStringValue​(java.lang.CharSequence stringValue)

      Set the string value of the node
      Parameters:
        `stringValue` - the string value of the node

    - #### setTypeAnnotation

          public void setTypeAnnotation​(SchemaType typeAnnotation)

      Set the type annotation of the node
      Specified by:
        `setTypeAnnotation` in interface `MutableNodeInfo`
      Parameters:
        `typeAnnotation` - the type annotation

    - #### setIsId

          public void setIsId​(boolean id)

      Set the isId property
      Parameters:
        `id` - the isId property

    - #### setIsIdref

          public void setIsIdref​(boolean idref)

      Set the isIdref property
      Parameters:
        `idref` - the isIdref property

    - #### setDisableOutputEscaping

          public void setDisableOutputEscaping​(boolean doe)

      Set the disable-output-escaping property
      Parameters:
        `doe` - true if the property is to be set

    - #### getNodeKind

          public int getNodeKind()

      Return the kind of node.
      Specified by:
        `getNodeKind` in interface `NodeInfo`
      Returns:
        one of the values Type.ELEMENT, Type.TEXT, Type.ATTRIBUTE, etc.
      See Also:
        `Type`

    - #### getFingerprint

          public int getFingerprint()

      Get fingerprint. The fingerprint is a coded form of the expanded name of the node: two nodes with the same name code have the same namespace URI and the same local name. The fingerprint contains no information about the namespace prefix. For a name in the null namespace, the fingerprint is the same as the name code.
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        an integer fingerprint; two nodes with the same fingerprint have the same expanded QName. For unnamed nodes (text nodes, comments, document nodes, and namespace nodes for the default namespace), returns -1.
      Throws:
        `java.lang.UnsupportedOperationException` - if this kind of node does not hold namepool fingerprints (specifically, if `hasFingerprint()` returns false).
      Since:
        8.4 (moved into FingerprintedNode at some stage; then back into NodeInfo at 9.8).

    - #### hasFingerprint

          public boolean hasFingerprint()

      Ask whether this NodeInfo implementation holds a fingerprint identifying the name of the node in the NamePool. If the answer is true, then the `getFingerprint()` method must return the fingerprint of the node. If the answer is false, then the `getFingerprint()` method should throw an `UnsupportedOperationException`. In the case of unnamed nodes such as text nodes, the result can be either true (in which case getFingerprint() should return -1) or false (in which case getFingerprint may throw an exception).
      Specified by:
        `hasFingerprint` in interface `NodeInfo`
      Returns:
        true if the implementation of this node provides fingerprints.
      Since:
        9.8; previously Saxon relied on using `FingerprintedNode` as a marker interface.

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value.
      Specified by:
        `atomize` in interface `Item`
      Specified by:
        `atomize` in interface `NodeInfo`
      Returns:
        the typed value.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
      Since:
        8.5

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the type annotation of this node, if any. The type annotation is represented as SchemaType object.

      Types derived from a DTD are not reflected in the result of this method.

      Specified by:
        `getSchemaType` in interface `NodeInfo`
      Returns:
        For element and attribute nodes: the type annotation derived from schema validation (defaulting to xs:untyped and xs:untypedAtomic in the absence of schema validation). For comments, text nodes, processing instructions, and namespaces: null. For document nodes, either xs:untyped if the document has not been validated, or xs:anyType if it has.
      Since:
        9.4

    - #### equals

          public boolean equals​(NodeInfo other)

      Determine whether this is the same node as another node.

      Note: a.equals(b) if and only if generateId(a)==generateId(b)

      Returns:
        true if this Node object and the supplied Node object represent the same node in the tree.

    - #### hashCode

          public int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Specified by:
        `hashCode` in interface `NodeInfo`
      Overrides:
        `hashCode` in class `java.lang.Object`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node. This will be the same as the System ID unless xml:base has been used.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node. This may be null if the base URI is unknown, including the case where the node has no parent.

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### compareOrder

          public int compareOrder​(NodeInfo other)

      Determine the relative position of this node and another node, in document order. The other node will always be in the same document.
      Specified by:
        `compareOrder` in interface `NodeInfo`
      Parameters:
        `other` - The other node, whose position is to be compared with this node
      Returns:
        -1 if this node precedes the other node, +1 if it follows the other node, or 0 if they are the same node. (In this case, isSameNode() will always return true, and the two nodes will produce the same result for generateId())

    - #### getStringValue

          public java.lang.String getStringValue()

      Return the string value of the node.
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Specified by:
        `getStringValue` in interface `Item`
      Specified by:
        `getStringValue` in interface `NodeInfo`
      Returns:
        the string value of the node
      See Also:
        `Item.getStringValueCS()`

    - #### getStringValueCS

          public java.lang.CharSequence getStringValueCS()

      Get the value of the item as a CharSequence. This is in some cases more efficient than the version of the method that returns a String.
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Specified by:
        `getStringValueCS` in interface `Item`
      Returns:
        the string value of the item
      See Also:
        `Item.getStringValue()`

    - #### getLocalPart

          public java.lang.String getLocalPart()

      Get the local part of the name of this node. This is the name after the ":" if any.
      Specified by:
        `getLocalPart` in interface `NodeInfo`
      Returns:
        the local part of the name. For an unnamed node, returns "".

    - #### getURI

          public java.lang.String getURI()

      Get the URI part of the name of this node. This is the URI corresponding to the prefix, or the URI of the default namespace if appropriate.
      Specified by:
        `getURI` in interface `NodeInfo`
      Returns:
        The URI of the namespace of this node. For an unnamed node, return null. For a node with an empty prefix, return an empty string.

    - #### getPrefix

          public java.lang.String getPrefix()

      Get the prefix of the name of the node. This is defined only for elements and attributes. If the node has no prefix, or for other kinds of node, return a zero-length string.
      Specified by:
        `getPrefix` in interface `NodeInfo`
      Returns:
        The prefix of the name of the node.

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getParent

          public NodeInfo getParent()

      Get the NodeInfo object representing the parent of this node
      Specified by:
        `getParent` in interface `NodeInfo`
      Returns:
        null - an Orphan has no parent.

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber)

      Return an iteration over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - the axis to be searched, e.g. Axis.CHILD or Axis.ANCESTOR
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber,
                                          java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iteration over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - the axis to be searched, e.g. Axis.CHILD or Axis.ANCESTOR
        `nodeTest` - A pattern to be matched by the returned nodes
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node
      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node of this tree (not necessarily a document node). Always returns this node in the case of an Orphan node.
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the top-level ancestor of this node. This will not necessarily be a document node. If this node has no parent, then the method returns this node.

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children.
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        false - an orphan node never has any children

    - #### generateId

          public void generateId​(FastStringBuffer buffer)

      Get a character string that uniquely identifies this node. Note: a.isSameNode(b) if and only if generateId(a)==generateId(b)
      Specified by:
        `generateId` in interface `NodeInfo`
      Parameters:
        `buffer` - a buffer, into which will be placed a string that uniquely identifies this node, within this document. The calling code prepends information to make the result unique across all documents.

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace undeclarations and undeclarations defined on this element.
      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### isId

          public boolean isId()

      Ask whether this node has the is-id property
      Specified by:
        `isId` in interface `NodeInfo`
      Returns:
        true if the node is an ID

    - #### isIdref

          public boolean isIdref()

      Ask whether this node has the is-idref property
      Specified by:
        `isIdref` in interface `NodeInfo`
      Returns:
        true if the node is an IDREF or IDREFS element or attribute

    - #### isDisableOutputEscaping

          public boolean isDisableOutputEscaping()

      Ask whether the node has the disable-output-escaping property
      Returns:
        true if the node has the disable-output-escaping property

    - #### insertChildren

          public void insertChildren​(NodeInfo[] source,
                                     boolean atStart,
                                     boolean inherit)

      Insert copies of a sequence of nodes as children of this node.

      This method takes no action unless the target node is a document node or element node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes will be copied to form the new children. Adjacent text nodes will be merged, and zero-length text nodes removed.

      Specified by:
        `insertChildren` in interface `MutableNodeInfo`
      Parameters:
        `source` - the nodes to be inserted
        `atStart` - true if the new nodes are to be inserted before existing children; false if they are
        `inherit` - true if the insert nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared

    - #### insertSiblings

          public void insertSiblings​(NodeInfo[] source,
                                     boolean before,
                                     boolean inherit)

      Insert copies of a sequence of nodes as siblings of this node.

      This method takes no action unless the target node is an element, text node, comment, or processing instruction, and one that has a parent node. It also takes no action in respect of any supplied nodes that are not elements, text nodes, comments, or processing instructions.

      The supplied nodes must use the same data model implementation as the tree into which they will be inserted.

      Specified by:
        `insertSiblings` in interface `MutableNodeInfo`
      Parameters:
        `source` - the nodes to be inserted
        `before` - true if the new nodes are to be inserted before the target node; false if they are
        `inherit` - true if the insert nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared

    - #### setAttributes

          public void setAttributes​(AttributeMap attributes)

      Set the attribute list for this (element) node
      Specified by:
        `setAttributes` in interface `MutableNodeInfo`
      Parameters:
        `attributes` - the new attribute list
      Throws:
        `java.lang.UnsupportedOperationException` - if this is not an element node

    - #### removeAttribute

          public void removeAttribute​(NodeInfo attribute)

      Remove an attribute from this element node

      If this node is not an element, or if it has no attribute with the specified name, this method takes no action.

      The attribute node itself is not modified in any way.

      Specified by:
        `removeAttribute` in interface `MutableNodeInfo`
      Parameters:
        `attribute` - the attribute node to be removed

    - #### addAttribute

          public void addAttribute​(NodeName nameCode,
                                   SimpleType attType,
                                   java.lang.CharSequence value,
                                   int properties,
                                   boolean inheritNamespaces)

      Add an attribute to this element node.

      If this node is not an element, or if the supplied node is not an attribute, the method takes no action. If the element already has an attribute with this name, the existing attribute is replaced.

      Specified by:
        `addAttribute` in interface `MutableNodeInfo`
      Parameters:
        `nameCode` - the name of the new attribute
        `attType` - the type annotation of the new attribute
        `value` - the string value of the new attribute
        `properties` - properties including IS_ID and IS_IDREF properties
        `inheritNamespaces` -

    - #### delete

          public void delete()

      Delete this node (that is, detach it from its parent).

      If this node has preceding and following siblings that are both text nodes, the two text nodes will be joined into a single text node (the identity of this node with respect to its predecessors is undefined).

      Specified by:
        `delete` in interface `MutableNodeInfo`

    - #### isDeleted

          public boolean isDeleted()

      Test whether this MutableNodeInfo object represents a node that has been deleted. Generally, such a node is unusable, and any attempt to use it will result in an exception being thrown
      Specified by:
        `isDeleted` in interface `MutableNodeInfo`
      Returns:
        true if this node has been deleted

    - #### replace

          public void replace​(NodeInfo[] replacement,
                              boolean inherit)

      Replace this node with a given sequence of nodes
      Specified by:
        `replace` in interface `MutableNodeInfo`
      Parameters:
        `replacement` - the replacement nodes
        `inherit` - true if the replacement nodes are to inherit the namespaces of their new parent; false if such namespaces are to be undeclared
      Throws:
        `java.lang.IllegalArgumentException` - if any of the replacement nodes is of the wrong kind. When replacing a child node, the replacement nodes must all be elements, text, comment, or PI nodes; when replacing an attribute, the replacement nodes must all be attributes.
        `java.lang.IllegalStateException` - if this node is deleted or if it has no parent node.

    - #### replaceStringValue

          public void replaceStringValue​(java.lang.CharSequence stringValue)

      Replace the string-value of this node. If applied to an element or document node, this causes all existing children to be deleted, and replaced with a new text node whose string value is the value supplied. The caller is responsible for checking that the value is valid, for example that comments do not contain a double hyphen; the implementation is not required to check for such conditions.
      Specified by:
        `replaceStringValue` in interface `MutableNodeInfo`
      Parameters:
        `stringValue` - the new string value

    - #### rename

          public void rename​(NodeName newNameCode,
                             boolean inheritNamespaces)

      Rename this node.

      This call has no effect if applied to a nameless node, such as a text node or comment.

      If necessary, a new namespace binding will be added to the target element, or to the element parent of the target attribute

      Specified by:
        `rename` in interface `MutableNodeInfo`
      Parameters:
        `newNameCode` - the namecode of the new name in the name pool
        `inheritNamespaces` -
      Throws:
        `java.lang.IllegalArgumentException` - if the new name code is not present in the name pool, or if it has a (prefix, uri) pair in which the prefix is the same as that of an existing in-scope namespace binding and the uri is different from that namespace binding.

    - #### addNamespace

          public void addNamespace​(NamespaceBinding nscode,
                                   boolean inherit)

      Add a namespace binding (that is, a namespace node) to this element. This call has no effect if applied to a node other than an element.
      Specified by:
        `addNamespace` in interface `MutableNodeInfo`
      Parameters:
        `nscode` - The namespace code representing the (prefix, uri) pair of the namespace binding to be added. If the target element already has a namespace binding with this (prefix, uri) pair, the call has no effect. If the target element currently has a namespace binding with this prefix and a different URI, an exception is raised.
      Throws:
        `java.lang.IllegalArgumentException` - if the namespace code is not present in the namepool, or if the target element already has a namespace binding for this prefix

    - #### removeTypeAnnotation

          public void removeTypeAnnotation()

      Remove type information from this node (and its ancestors, recursively). This method implements the upd:removeType() primitive defined in the XQuery Update specification. (Note: the caller is responsible for updating the set of nodes marked for revalidation)
      Specified by:
        `removeTypeAnnotation` in interface `MutableNodeInfo`

    - #### newBuilder

          public Builder newBuilder()

      Get a Builder suitable for building nodes that can be attached to this document. This implementation always throws an exception: the method should only be called on a document or element node when creating new children.
      Specified by:
        `newBuilder` in interface `MutableNodeInfo`
      Returns:
        a new Builder that constructs nodes using the same object model implementation as this one, suitable for attachment to this tree